/// Generated By XFlutter Cli.
///
/// more info: https://medium.com/@aghiadodeh
import 'package:flutter/material.dart';
import 'package:flutterx_live_data/flutterx_live_data.dart';
import 'package:flutter_mvvm_example/ui/widgets/text_fields/livedata_text_field.dart';
import 'package:flutter_mvvm_example/ui/widgets/buttons/customized_button.dart';
import 'package:flutter_mvvm_example/ui/resources/dimensions/dimensions.dart';
import 'package:flutter_mvvm_example/models/forms/formz_email.dart';
import 'package:flutter_mvvm_example/models/forms/formz_password.dart';

import "package:flutter_mvvm_example/ui/widgets/singleton/singleton_widget.dart";
import '../viewmodels/login_viewmodel.dart';
import 'package:flutter_mvvm_example/ui/core/layouts/theme_widget.dart';

class LoginForm extends StatelessWidget {
  const LoginForm({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return SingletonWidget<LoginViewModel>(
      builder: (viewModel) {
        return ThemeWidget(
          builder: (context, theme) {
            return Column(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Column(
                  children: [
                    ///// Login Email /////
                    LiveDataTextField<FormzEmail>(
                      label: 'email',
                      liveData: viewModel.params.email,
                      onTextChanged: viewModel.formzEmailChanged,
                      errorText: () => viewModel.params.email.value.error?.message,
                      keyboardType: TextInputType.emailAddress,
                    ),
                    const SizedBox(height: formSpacing),

                    ///// Login Password /////
                    LiveDataTextField<FormzPassword>(
                      label: 'password',
                      liveData: viewModel.params.password,
                      onTextChanged: viewModel.formzPasswordChanged,
                      errorText: () => viewModel.params.password.value.error?.message,
                      obscureText: true,
                    ),
                    const SizedBox(height: formSpacing),
                  ],
                ),

                ///// Form Submit /////
                CombinedLiveDataBuilder.with2<FormzEmail, FormzPassword, bool>(
                  x1: viewModel.params.email,
                  x2: viewModel.params.password,
                  transform: (a, b) => a.valid && b.valid,
                  builder: (context, boolean) {
                    return SizedBox(
                      width: double.infinity,
                      child: CustomizedButton(
                        enabled: boolean,
                        callback: viewModel.login,
                        child: const Text("Submit"),
                      ),
                    );
                  },
                ),
              ],
            );
          },
        );
      },
    );
  }
}
